#version 330

in vec2 TexCoord;
out vec4 FragColor;

uniform float exposure;
uniform float decay;
uniform float density;
uniform float weight;
uniform vec2 lightPositionOnScreen;
uniform sampler2D firstPass;
const int NUM_SAMPLES = 100 ;

void main()
{

  vec2 deltaTextCoord = vec2( TexCoord.st - lightPositionOnScreen.xy );
  vec2 textCoo = TexCoord.st;
  deltaTextCoord *= 1.0 /  float(NUM_SAMPLES) * density;
  float illuminationDecay = 0.6;
  vec4 newfrag = vec4(0,0,0,0);
  for(int i=0; i < NUM_SAMPLES ; i++)
  {
    textCoo -= deltaTextCoord;
    vec4 sample = texture2D(firstPass, textCoo );

    sample *= illuminationDecay * weight;

    newfrag += sample;

    illuminationDecay *= decay;
  }
  FragColor = newfrag;
  //FragColor= vec4( lightPositionOnScreen.xy,0,1);
  FragColor *= exposure;
  FragColor -=vec4(0.05,0.05,0.05,0);
  //FragColor = texture2D(firstPass, TexCoord.xy);

}