#version 330

layout (location = 0) in vec3 Position;
layout (location = 1) in vec2 TexCoord;
layout (location = 2) in vec3 Normal;
layout (location = 3) in vec3 Tangent;

uniform mat4 gWVP;
uniform mat4 gVP;
uniform mat4 gWorld;  


out vec2 TexCoord0;
out vec3 NormalW;
out vec3 Tangent0;

void main()
{
	
    gl_Position = (gWVP *  vec4(Position, 1.0));
    TexCoord0 = TexCoord;
	NormalW = (gWorld * vec4(Normal,0.0)).xyz;
	Tangent0 = (gWorld * vec4(Tangent, 0.0)).xyz;

}
