#version 410 core     


in vec2 TexCoord_FS;
in vec3 Normal_FS;
in vec3 WorldPos_FS;
out vec4 FragColor;


struct DiffuseLight                                                    
{                                                                                   
    vec3 color;                                                                                                                           
    float diffuseIntensity;                                                         
    vec3 direction;                                                                 
};

uniform mat4 gWorld; 
uniform sampler2D gSampler;
uniform DiffuseLight diffuseLight;
uniform float ambientIntensity;

void main()
{
    vec4 ambientColor = vec4(0.5f,0.5f,0.5f,1.0f) * ambientIntensity;
   
   float diffuseFactor = dot(Normal_FS , -normalize(diffuseLight.direction));

   vec4 diffuseColor;
   diffuseColor = vec4(diffuseLight.color, 1.0f) *
                        diffuseLight.diffuseIntensity *
                        diffuseFactor;

   FragColor = texture2D(gSampler, TexCoord_FS.xy) * diffuseColor  ;

}